
local StoneGateV6 = ...

-- Apply building asset processor
--StoneGateV6:registerAssetProcessor("models/machicolations/machicolationSmallGate.fbx", {
--	DataType = "BUILDING_ASSET_PROCESSOR"
--})
StoneGateV6:registerAssetProcessor("models/machicolations/machicolationCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register Circular Tower materials
StoneGateV6:registerAssetId("models/machicolations/machicolationCircularTower.fbx/Materials/redRoof", StoneGateSetPrefix .. "_CIRCULAR_MACHICOLATION_RED_ROOF_MATERIAL")
StoneGateV6:registerAssetId("models/machicolations/machicolationCircularTower.fbx/Materials/blueRoof", StoneGateSetPrefix .. "_CIRCULAR_MACHICOLATION_BLUE_ROOF_MATERIAL")
StoneGateV6:registerAssetId("models/machicolations/machicolationCircularTower.fbx/Materials/brownRoof", StoneGateSetPrefix .. "_CIRCULAR_MACHICOLATION_BROWN_ROOF_MATERIAL")
StoneGateV6:registerAssetId("models/machicolations/machicolationCircularTower.fbx/Materials/greyRoof", StoneGateSetPrefix .. "_CIRCULAR_MACHICOLATION_GREY_ROOF_MATERIAL")
StoneGateV6:registerAssetId("models/machicolations/machicolationCircularTower.fbx/Materials/grey2Roof", StoneGateSetPrefix .. "_CIRCULAR_MACHICOLATION_GREY2_ROOF_MATERIAL")

function registerMachicolationPart(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV6:registerAssetId("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the machicolation part
    StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    StoneGateV6:registerPrefabComponent("models/machicolations/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = _buildingZone
    })
end

--registerMachicolationPart( "machicolationSmallGate","step_4_SGate_MachicolationA", "SGATE_MACHICOLATION_A", { 0, 0 } )
--registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingL", "SGATE_MACHICOLATION_CLOSING_L", { 0, 0 } )
--registerMachicolationPart( "machicolationSmallGate","step_5_SGate_MachicolationClosingR", "SGATE_MACHICOLATION_CLOSING_R", { 0, 0 } )
--registerMachicolationPart( "machicolationSmallGate","step_4_SGate_WoodenRoofA", "SGATE_MACHICOLATION_WOODEN_ROOF_A", { 0, 0 } )
--registerMachicolationPart( "machicolationSmallGate","step_4_SGate_StoneRoofA", "SGATE_MACHICOLATION_STONE_ROOF_A", { 0, 0 } )
registerMachicolationPart( "machicolationCircularTower","step_4_Circular_MachicolationA", "CIRCULAR_MACHICOLATION_A", { 0, 0 } )
registerMachicolationPart( "machicolationCircularTower","step_4_Circular_MachicolationB", "CIRCULAR_MACHICOLATION_B", { 0, 0 } )
registerMachicolationPart( "machicolationCircularTower","step_6_Circular_MachicolationRoof", "CIRCULAR_MACHICOLATION_PLATFORM", { 0, 0 } )
